function [compfield,c2,l2,l2normRecovery,compressScore] = compress(field, wave_name, comp_level, opt, thr, sorh, keepapp, basisType)

switch basisType
  case 1
    % data compression with one type of wavelet
    [c l] = wavedec2(field, comp_level, wave_name); % decomposition
    [compfield, c2, l2, l2normRecovery, compressScore] = wdencmp(opt, c, l, wave_name, comp_level, thr, sorh, keepapp);
    compressScore = nnz(c2)/(size(field,1)*size(field,2));
  case 2
    %addpath('../CurveLab-2.1.3/fdct_wrapping_matlab');
    % curvelet transform *****
    is_real = true;
    finest = 2; % 2 = wavelets at finest level, 1 = curevelets
    numberOfAngles = 8; % minimum 8, must be multiple of 4
    c2 = fdct_wrapping(field,is_real,2,comp_level,numberOfAngles);
    nonzeros = 0;
    total = 0;
    threshold = 0;
    for s=1:length(c2)
      for w=1:length(c2{s})
        threshold = max(threshold,max(max(abs(c2{s}{w})))/thr); 
      end
    end
    for s=1:length(c2)
      for w=1:length(c2{s})
        c2{s}{w} = (c2{s}{w}).*(abs(c2{s}{w}) > threshold);
        nonzeros = nonzeros + nnz(c2{s}{w});
        total = total + size(c2{s}{w},1)*size(c2{s}{w},2);
      end
    end
    compfield = ifdct_wrapping(c2,is_real,size(field,1),size(field,2));
    l2 = 0;% ******
    l2normRecovery = norm(compfield,'fro')/norm(field,'fro');
    compressScore = nonzeros/(size(field,1)*size(field,2)); % ****
end
